#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include "vga.h"
#include "mys.h"

typedef float tip;

struct bodvektor {
  tip x, y;
  tip vx, vy;
  unsigned char b;
};

struct bod {
  tip x, y;
};

struct bodb {
  unsigned int x, y;
  unsigned char b;
};

struct vektor {
  tip x, y;
};

void objdef(bodvektor telesa[], unsigned int poc) {
  unsigned int i = 0, j = 0, k = 0;
  randomize();
  for(i = 0; i < poc; i ++) {
	telesa[i].x = random(1000)/20+100;
	telesa[i].y = random(1000)/25+80;
//	telesa[i].vx = (tip)random(10)/10;
//	telesa[i].vy = (tip)random(20)/10-1;
//	telesa[i].x = 200+(tip)k/2;
//	telesa[i].y = 100+(tip)j/2;
//	telesa[i].x = 50;
//	telesa[i].y = 100;
	telesa[i].vx = 1;
	telesa[i].vy = -1;
	j ++;
	if (j == 30) {
	  j = 0;
	  k ++;
	}
  }
}

void fordef(vektor sily[], unsigned int poc) {
  unsigned int i = 0;
  for(i = 0; i < poc; i ++) {
	sily[i].x = 0;
	sily[i].y = 0.01;
  }
}

void wrddef(void) {
  unsigned char b;
  tip x, y;
  setcolor(14);
  randomize();
  for(b = 1; b <= 14; b += 1) {
	for(x = 0; x < getmaxx(); x += 0.1) {
//	  y = sin(x*0.01)*sin(x*0.2)*20+cos(x*0.1)*x*0.1+sin(x*0.01-1)*50+100+b*10;
//	  y = cos(x*0.005-2)*150+sin(x*0.1)*x*0.01+100+b*0.5;
	  y = pow(2 , sin(x*0.05)*5)+sin(x*0.03)*x*0.1+200+b*0.5;
	  putpixel(x, y, b);
	}
  }
  setfillstyle(1,14);
  floodfill(0,300,14);
  /*
  line(0,0,200,200);
  line(200,200,200,240);
  line(200,240,400,300);
  line(400,300,500,300);
  line(500,300,getmaxx(),0);
  */
}

void kresli(bodvektor telesa[], unsigned int poc, unsigned char barva) {
  unsigned int i = 0;
  for(i = 0; i < poc; i ++) {
	telesa[i].b = getpixel(telesa[i].x, telesa[i].y);
	if (telesa[i].b == barva) telesa[i].b = 255;
	putpixel(telesa[i].x, telesa[i].y, barva);
  }
}

void smaz(bodb pozice[], unsigned int poc) {
  unsigned int i = 0;
  for(i = 0; i < poc; i ++) {
	if (pozice[i].b != 255) putpixel(pozice[i].x, pozice[i].y, pozice[i].b);
  }
}

void zrychleni(bodvektor telesa[], vektor sily[], unsigned int poct, unsigned int pocs) {
  unsigned int i = 0, j = 0;
  for(i = 0; i < pocs; i ++) {
	for(j = 0; j < poct; j ++) {
	  telesa[j].vx += sily[i].x;
	  telesa[j].vy += sily[i].y;
	}
  }
}

bod draha(bodvektor teleso, unsigned char odraz, tip vzd) {
  tip v, t, tx, ty;
  unsigned char barva = 0;
  bod pom;
  pom.x = 0;
  pom.y = 0;
  v = sqrt(teleso.vx*teleso.vx + teleso.vy*teleso.vy);
  if (v > 0) {
	t = 0;
	while ((t < (v+vzd))&(barva != odraz)) {
	  tx = t/v * teleso.vx;
	  ty = t/v * teleso.vy;
	  barva = getpixel(teleso.x + tx, teleso.y + ty);
	  t += 0.5;
	  ;
	}
  }
  pom.x = teleso.x + tx;
  pom.y = teleso.y + ty;
  return(pom);
}

vektor odrzvekt(bod c, vektor w, vektor v) {
  tip n, k;
  bod b;
  vektor pom;
  n = (v.x*w.y - v.y*w.x)/(w.x*w.x + w.y*w.y);
  k = (-v.x + n*w.y)/w.x;
  pom.x = + v.x - 2*n*w.y;
  pom.y = - k*w.y + n*w.x;
  return(pom);
}

void prostredi(bodvektor telesa[], int poc) {
  int i = 0;
  bod c;
//  unsigned char b = 0;
  for(i = 0; i < poc; i ++) {
	c = draha(telesa[i], 14, 0.5);
	if (getpixel(c.x, c.y) == 14) {
	  tip v;
	  v = sqrt(telesa[i].vx*telesa[i].vx + telesa[i].vy*telesa[i].vy);
	  if (v > 0) {
		bodvektor b1, b2;
		bod a, b;
		vektor w, u, t;

		b1.x = telesa[i].x - telesa[i].vy/v*2 - telesa[i].vx*5;
		b1.y = telesa[i].y + telesa[i].vx/v*2 - telesa[i].vy*5;
		b1.vx = telesa[i].vx;
		b1.vy = telesa[i].vy;
		b2.x = telesa[i].x + telesa[i].vy/v*2 - telesa[i].vx*5;
		b2.y = telesa[i].y - telesa[i].vx/v*2 - telesa[i].vy*5;
		b2.vx = telesa[i].vx;
		b2.vy = telesa[i].vy;
		a = draha(b1,14,20);
		b = draha(b2,14,20);
//		putpixel(a.x, a.y, 12);
//		putpixel(b.x, b.y, 12);
		w.x = a.x - b.x;
		w.y = a.y - b.y;
		t.x = telesa[i].vx;
		t.y = telesa[i].vy;
		c.x = telesa[i].x;
		c.y = telesa[i].y;
		u = odrzvekt(c, w, t);
		telesa[i].vx = u.x;
		telesa[i].vy = u.y;
		telesa[i].vx *= 0.8;
		telesa[i].vy *= 0.8;
/*
		v = sqrt(telesa[i].vx*telesa[i].vx + telesa[i].vy*telesa[i].vy);
		if (v > 0.05) {
		  for (int q = 0; q < 100; q ++) {
			sound(v*200+500-q);
		  }
		  nosound();
		}
*/
	  }
	}
  }
}

void posunuti(bodvektor telesa[], unsigned int poc) {
  unsigned int i = 0;
  for(i = 0; i < poc; i ++) {
	telesa[i].x += telesa[i].vx;
	telesa[i].y += telesa[i].vy;
  }
}

void omezeni(bodvektor telesa[], unsigned int poc) {
  unsigned int i = 0;
  for(i = 0; i < poc; i ++) {
	if (telesa[i].x > getmaxx()) telesa[i].x = getmaxx();
	if (telesa[i].y > getmaxy()) telesa[i].y = getmaxy();
	if (telesa[i].x < 0) telesa[i].x = 0;
	if (telesa[i].y < 0) telesa[i].y = 0;
  }
}


void prepocti(bodvektor telesa[], vektor sily[], unsigned int poct, unsigned int pocs) {
  zrychleni(telesa, sily, poct, pocs);
  prostredi(telesa, poct);
  posunuti(telesa, poct);
  omezeni(telesa, poct);
}

void kopiruj(bodvektor telesa[], bodb pozice[], unsigned int poc) {
  unsigned int i = 0;
  for(i = 0; i < poc; i ++) {
	pozice[i].x = telesa[i].x;
	pozice[i].y = telesa[i].y;
	pozice[i].b = telesa[i].b;
  }
}

class clanek {
 public:
  int m;
  vektor poloha;
  vektor rychlost;
};

class retizek {
 public:
  clanek *clanky;
  int pocet;
  tip pruznost, norma, treni;

  retizek(int poc, int m, tip n,tip p, tip t) {
    if (poc > 1) pocet = poc;
    else pocet = 2;
    pruznost = p;
    norma = n;
    treni = t;
    clanky = new clanek[pocet];
    int i;
    for (i = 0; i < pocet; i ++) {
      clanky[i].m = m;
      clanky[i].poloha.x = 20 + i*10;
      clanky[i].poloha.y = 20;
      clanky[i].rychlost.x = 0;
      clanky[i].rychlost.y = 0;
    }
  }

  ~retizek() {
    delete clanky;
  }

  void prepocti(void) {
    int i;
    tip sila, vzd;
    for (i = 1; i < pocet; i ++) {
      vzd = sqrt( pow(clanky[i-1].poloha.x - clanky[i].poloha.x, 2) + pow(clanky[i-1].poloha.y - clanky[i].poloha.y, 2) );
      sila = (1-norma/vzd)*(clanky[i-1].poloha.x - clanky[i].poloha.x)*pruznost + (clanky[i-1].rychlost.x - clanky[i].rychlost.x)*treni;
      clanky[i-1].rychlost.x -= sila/clanky[i-1].m;
      clanky[i].rychlost.x += sila/clanky[i].m;

      sila = (1-norma/vzd)*(clanky[i-1].poloha.y - clanky[i].poloha.y)*pruznost + (clanky[i-1].rychlost.y - clanky[i].rychlost.y)*treni;
      clanky[i-1].rychlost.y -= sila/clanky[i-1].m;
      clanky[i].rychlost.y += sila/clanky[i].m;
    }
  }

  void posun(void) {
    int i;
    for (i = 0; i < pocet; i ++) {
      clanky[i].poloha.x += clanky[i].rychlost.x;
      clanky[i].poloha.y += clanky[i].rychlost.y;
    }
  }

  void gravitace(tip g) {
    int i;
    for (i = 0; i < pocet; i ++) {
      clanky[i].rychlost.y += g;
    }
  }

  void stop(int ktery, int x, int y) {
    if ((ktery >= 0)&&(ktery < pocet)) {
      clanky[ktery].poloha.x = x;
      clanky[ktery].poloha.y = y;
      clanky[ktery].rychlost.x = 0;
      clanky[ktery].rychlost.y = 0;
    }
    if (ktery == -1) {
      clanky[pocet -1].poloha.x = x;
      clanky[pocet -1].poloha.y = y;
      clanky[pocet -1].rychlost.x = 0;
      clanky[pocet -1].rychlost.y = 0;
    }
  }

  void kresli(void) {
    int i = 0;
    moveto(clanky[i].poloha.x, clanky[i].poloha.y);
    for (i = 1; i < pocet; i ++) {
//      lineto(clanky[i].poloha.x, clanky[i].poloha.y);
      putpixel(clanky[i].poloha.x, clanky[i].poloha.y, 15);
    }
  }

};

const poct = 20;
const pocs = 1;
bodvektor telesa[100];
bodb pozice[100];
vektor sily[1];

void main(void) {
  initvga(1);
  int i;

  gray();
  struct palettetype pal;
  getpalette(&pal);
  setrgbpalette(pal.colors[15], 60, 0, 0);

  mouse mys;
  mys.set_off();
  mys.set_xy(20,20);
  retizek guma(poct, 10, 5, 4, 4);

  objdef(telesa, poct);
  fordef(sily, pocs);

  swapactivep();
  wrddef();
  swapvisualp();
  swapactivep();
  wrddef();
  getch();
  while(!kbhit()) {
	swapactivep();
	mys.aktual();
	smaz(pozice, poct);
	kopiruj(telesa, pozice, poct);

	guma.stop(-1, mys.get_x(), mys.get_y());
	guma.prepocti();
	guma.gravitace(0.1);
	for (i = 0; i < poct; i ++) {
	  telesa[i].x = guma.clanky[i].poloha.x;
	  telesa[i].y = guma.clanky[i].poloha.y;
	  telesa[i].vx = guma.clanky[i].rychlost.x;
	  telesa[i].vy = guma.clanky[i].rychlost.y;
	}
	prostredi(telesa, poct);
	for (i = 0; i < poct; i ++) {
	  guma.clanky[i].poloha.x = telesa[i].x;
	  guma.clanky[i].poloha.y = telesa[i].y;
	  guma.clanky[i].rychlost.x = telesa[i].vx;
	  guma.clanky[i].rychlost.y = telesa[i].vy;
	}
	guma.posun();

//	prepocti(telesa, sily, poct, pocs);
	kresli(telesa, poct, 15);
//	guma.kresli();
	delay(1);
	swapvisualp();
	delay(10);
  }

  closegraph();
}